unit display_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Shape9: TShape;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    Shape13: TShape;
    Shape14: TShape;
    Shape15: TShape;
    Shape16: TShape;
    Shape17: TShape;
    Shape18: TShape;
    Shape19: TShape;
    Shape20: TShape;
    Shape21: TShape;
    Shape22: TShape;
    Shape23: TShape;
    Shape24: TShape;
    Shape25: TShape;
    Shape26: TShape;
    Shape27: TShape;
    Shape28: TShape;
    Shape29: TShape;
    Shape30: TShape;
    Shape31: TShape;
    Shape32: TShape;
    Shape33: TShape;
    Shape34: TShape;
    Shape35: TShape;
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Button2: TButton;
    Button3: TButton;
    Edit6: TEdit;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ChangeColor(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    a : array[1..35] of TShape;
    { Private-Deklarationen}
      public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;
  s1,s2,s3,s4,s5 : string;
  DAtenListe : TStringList;
implementation

{$R *.DFM}

const h : array[0..3] of integer = (4096,256,16,1);
      hz : array[0..15] of char = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
      hexziffern : set of char = ['0','1','2','3','4','5','6','7','8','9','0','A','B','C','D','E','F'];
      dezziffern : set of char = ['0','1','2','3','4','5','6','7','8','9'];
      binziffern : set of char = ['0','1'];

var      z1,z2 : integer;

function bin( s: integer): string;
var hs : string;
    k : byte;
begin
hs := '';
for k := 0 to 7 do begin
   if (s and 1)= 1 then hs := '1'+hs  else hs := '0'+hs;
   s := s shr 1;
end;
while (hs[1] = '0') and (hs <>'0') do delete(hs,1,1);
result := hs;
end;


function bin2int(s:string) : integer;
var w,k : integer;
begin
while length(s) < 16 do s := '0'+s;
w := 0;
for k := 1 to 16 do begin
   w := 2*w;
   if s[k] = '1' then w := w+1;
end;
result := w;
end;

function hex( s: integer): string;
var hs : string;
    k,r,q : byte;
begin
for k := 2 to 3 do begin
   q := s div h[k];
   r := s mod h[k];
   hs := hs+hz[q];
   s := r
end;
result := hs;
end;

function hex2int(s:string) : integer;
var hs,i,k : integer;
     ch : char;
begin
hs := 0;
while length(s) <4  do s := '0'+s;
for k := 1 to 4 do begin
   ch := s[k];
   i := 0;
   while ch <> hz[i] do inc(i);
   hs := 16*hs;
   hs := hs +i;
end;
result := hs;
end;



procedure TForm1.FormCreate(Sender: TObject);
var z,n : integer;
    shape : Tshape;
begin
for n := 0 to componentcount-1 do
   if components[n] is TShape then begin
      shape := components[n] as TShape;
      z := shape.tag;
      a[z] := shape;
    end;
DatenListe := TStringList.Create;
DAtenListe.Add(chr(9)+'addwf pc,1');
end;


procedure TForm1.ChangeColor(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
begin
with(sender as TShape) do
if brush.color = clred then brush.color := clwhite else brush.color := clred;
end;



procedure TForm1.Button1Click(Sender: TObject);
var Temp : TComponent;
    t,c,n : integer;

begin
s1 := '';s2 := '';s3 := '' ; s4 := ''; s5 := '';
for n:= 0 to ComponentCount-1 do begin
  temp := Components[n];
  if (temp is TShape) then begin
  t := (Temp as TShape).tag;
  case t of
  1..7  : if (temp as TShape).Brush.color = clred then s1 := s1 +'1' else s1 := s1+'0';
  8..14 : if (temp as TShape).Brush.color = clred then s2 := s2 +'1' else s2 := s2+'0';
  15..21 : if (temp as TShape).Brush.color = clred then s3 := s3 +'1' else s3 := s3+'0';
  22..28 : if (temp as TShape).Brush.color = clred then s4 := s4 +'1' else s4 := s4+'0';
  29..35 : if (temp as TShape).Brush.color = clred then s5 := s5 +'1' else s5 := s5+'0';
  end;
end;
end;
s1 := hex(bin2Int(s1)); Edit1.Text := s1;
s2 := hex(bin2Int(s2)); Edit2.Text := s2;
s3 := hex(bin2Int(s3)); Edit3.Text := s3;
s4 := hex(bin2Int(s4)); Edit4.Text := s4;
s5 := hex(bin2Int(s5)); Edit5.Text := s5;
end;

procedure TForm1.Button2Click(Sender: TObject);
var n : integer;
    temp : TComponent;
begin
for n:= 0 to ComponentCount-1 do begin
  temp := Components[n];
  if temp is TShape then
  if (temp as TShape).Brush.Color = clRed then  (Temp as TShape).Brush.Color := clwhite;
end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
DatenListe.Add(Edit6.Text);
DatenListe.Add(chr(9)+'retlw'+chr(9)+'0'+s1);
DatenListe.Add(chr(9)+'retlw'+chr(9)+'0'+s2);
DatenListe.Add(chr(9)+'retlw'+chr(9)+'0'+s3);
DatenListe.Add(chr(9)+'retlw'+chr(9)+'0'+s4);
DatenListe.Add(chr(9)+'retlw'+chr(9)+'0'+s5);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
DatenListe.SaveToFile('otto.txt');
end;

end.
